#!/bin/bash

echo
echo "*** Fix Mac Fiery XF permission problems with your installation ***"
echo "    Please enter your admin password when requested"
echo

LoggedInUser=$(/bin/ls -l /dev/console | /usr/bin/awk '{ print $3 }')

######################################
# Set file/folder permissions SERVER #
######################################
if [ -e "/Applications/EFI Fiery XF/Server" ]; then

  sudo chown root:wheel "/Library/LaunchDaemons/com.efi.jdfserver.plist"
  sudo chmod 644 "/Library/LaunchDaemons/com.efi.jdfserver.plist"

  sudo chown root:wheel "/Library/LaunchDaemons/com.efi.license.plist"
  sudo chmod 644 "/Library/LaunchDaemons/com.efi.license.plist"

  sudo chown root:wheel "/Library/LaunchDaemons/com.efi.licensedelay.plist"
  sudo chmod 644 "/Library/LaunchDaemons/com.efi.licensedelay.plist"

  sudo chown root:wheel "/Library/LaunchDaemons/com.efi.virtualspooler.plist"
  sudo chmod 644 "/Library/LaunchDaemons/com.efi.virtualspooler.plist"

  sudo chown root:wheel "/Library/LaunchDaemons/com.efi.xfserver.plist"
  sudo chmod 644 "/Library/LaunchDaemons/com.efi.xfserver.plist"

  sudo chown root:wheel "/usr/libexec/aksusbd"
  sudo chmod 755 "/usr/libexec/aksusbd"

  sudo chown root:wheel "/usr/libexec/cups/backend/xfspooler"
  sudo chmod 755 "/usr/libexec/cups/backend/xfspooler"

  sudo chmod -R 775 "/Applications/FlexLM"
  
  #------------------------------
  sudo chown -R "$LoggedInUser:20" "/Applications/EFI Fiery XF/Server"
  sudo chown -R "$LoggedInUser:20" "/Applications/EFI Fiery XF/Tools"
  sudo chown -R "$LoggedInUser:20" "/Applications/EFI Fiery XF/JDF"
  sudo chown "$LoggedInUser:20" "/Applications/EFI Fiery XF"

  sudo chmod -R 775 "/Applications/EFI Fiery XF/Server"
  sudo chmod -R 775 "/Applications/EFI Fiery XF/Tools"
  sudo chmod -R 775 "/Applications/EFI Fiery XF/JDF"
  sudo chmod 775 "/Applications/EFI Fiery XF"

  #------------------------------
  sudo chown -R "$LoggedInUser":20 "/Library/Application Support/EFI/EFI XF/Server"
  sudo chown -R "$LoggedInUser":20 "/Library/Application Support/EFI/EFI XF/JDF"
  sudo chown "$LoggedInUser":20 "/Library/Application Support/EFI/EFI XF"
  sudo chown "$LoggedInUser":20 "/Library/Application Support/EFI"

  sudo chmod -R 777 "/Library/Application Support/EFI/EFI XF/Server"
  sudo chmod -R 777 "/Library/Application Support/EFI/EFI XF/JDF"
  sudo chmod 777 "/Library/Application Support/EFI/EFI XF"
  sudo chmod 777 "/Library/Application Support/EFI"

  echo "    Repaired permissions for Fiery XF Server."
else
  echo "    Fiery XF Server is not available on this system"
  echo "    its folders are skipped for repair."
fi

######################################
# Set file/folder permissions CLIENT #
######################################
if [ -e "/Applications/EFI Fiery XF/Client" ]; then

  sudo chown "$LoggedInUser:20" "/Applications/EFI Fiery XF"
  sudo chmod 775 "/Applications/EFI Fiery XF"

  sudo chown -R "$LoggedInUser:20" "/Applications/EFI Fiery XF/Client"
  sudo chmod -R 775 "/Applications/EFI Fiery XF/Client"

  sudo chown -R "$LoggedInUser:20" "/Applications/EFI Fiery XF/Tools"
  sudo chmod -R 775 "/Applications/EFI Fiery XF/Tools"

  sudo chown "$LoggedInUser:20" "/Library/Application Support/EFI"
  sudo chmod 777 "/Library/Application Support/EFI"

  sudo chown "$LoggedInUser:20" "/Library/Application Support/EFI/EFI XF"
  sudo chmod 777 "/Library/Application Support/EFI/EFI XF"

  sudo chown -R "$LoggedInUser:20" "/Library/Application Support/EFI/EFI XF/Client"
  sudo chmod -R 777 "/Library/Application Support/EFI/EFI XF/Client"

  echo "    Repaired permissions for Fiery XF Client."
else
  echo "    Fiery XF Client is not available on this system"
  echo "    its folders are skipped for repair."
fi
